
/*

	Fire Routine for Net Yaroze 

	(c) F Javier Ventoso Reigosa X'97

	javier0003@mundivia.es  or  javier_ventoso@iname.com


	You can use it in your games if you want!

	Push PADup and down to change FirePower

*/

#include <libps.h>
#include "pad.h"

#define SCREEN_WIDTH    512
#define SCREEN_HEIGHT   256

static u_long PadRead(long);
static long CheckPad ();
static void Draw_Fire( void );

#define OT_LENGTH 1

GsOT WorldOT[2];
GsOT_TAG OTTags[2][1<<OT_LENGTH];
int activeBuff;

PACKET GpuPacketArea[2][5000*24];

GsBOXF FireBox;
short FirePower = 4;
short Xleft = -256;
short Yup = -128;
volatile u_char *bb0, *bb1;

void main ()
{
	int i;

	ResetGraph( 0 );
	SetVideoMode( MODE_PAL );
	GsInitGraph( SCREEN_WIDTH, SCREEN_HEIGHT, GsNONINTER|GsOFSGPU, 1, 0 );
	GsDefDispBuff( 0, 0, 0, SCREEN_HEIGHT );
	GsDISPENV.screen.h = 256;
	GsInit3D();

	for( i=0; i<2; i++ )
	{
		WorldOT[i].length = OT_LENGTH;
		WorldOT[i].org = OTTags[i];
	}

	GetPadBuf(&bb0,&bb1);

	// ajustar tamao del bloque de fuego
	FireBox.w = 4;
	FireBox.h = 8;

	printf( "\n\nPush UP and DOWN to change FirePower \n\n" );

	while( 1 )
	{
		activeBuff = GsGetActiveBuff();
		GsSetWorkBase( (PACKET *) GpuPacketArea[activeBuff] );
		GsClearOt( 0, 0, &WorldOT[activeBuff] );

		Draw_Fire();

		DrawSync( 0 );
		VSync( 0 );

		if( CheckPad() == 99 )
			break;

		GsSwapDispBuff();
		GsSortClear( 0, 0, 0, &WorldOT[activeBuff] );
		GsDrawOt( &WorldOT[activeBuff] );
	}

	ResetGraph( 0 );
}

static u_long PadRead(long id)
{
	return (~(*(bb0+3) | *(bb0+2) << 8 | *(bb1+3) << 16 | *(bb1+2) << 24));
}

static long CheckPad( void )
{
	u_long padd = PadRead( 1 );

	if( padd & PADselect ) return( 99 );

	// ajustar altura de las brasas
	if( padd & PADLup || padd & PADRup )
	{
		FirePower -= 1;
		if( FirePower == 0 ) FirePower = 1;
	}
	if( padd & PADLdown || padd & PADRdown )
	{
		FirePower += 1;
		if( FirePower >= 10 ) FirePower = 10;
	}

	return( 0 );
}

static void Draw_Fire( void )
{
	static unsigned char current[34][128];
	static unsigned char working[34][128];
	short pix1, pix2, pix3, pix4, pix5, color;
	short fil, col;

	// generar lneas aleatorias de brasas
	for( col = 0; col < 128; col++ )
	{
		working[32][col] = rand() % 256;
		working[33][col] = working[32][col];
	}

	// hallar valores medios
	for( fil = 33; fil >= 2; fil-- )
	for( col = 1; col <= 127; col++ )
	{
		pix1 = current[fil-1][col]; // arriba
		pix2 = current[fil][col+1]; // derecha
		pix3 = current[fil][col-1]; // izquierda
		pix4 = current[fil+1][col+1]; // arriba/derecha
		pix5 = current[fil+1][col-1]; // arriba/izquierda
		color = (pix1+pix2+pix3+pix4+pix5)/5;
		if( color > FirePower ) color -= FirePower;
		working[fil-1][col] = ( unsigned char ) color;
	}

	// copiar working a current
	for( fil = 0; fil < 34; fil++ )
	for( col = 0; col < 128; col++ )
		current[fil][col] = working[fil][col];

	// generar paquetes de vdeo
	for( fil = 0; fil < 32; fil++ )
	for( col = 0; col < 128; col++ )
	{
		FireBox.x = col*4 + Xleft;
		FireBox.y = fil*8 + Yup;
		FireBox.r = FireBox.g = FireBox.b = 0;
		if( current[fil][col] < 20 )
			FireBox.r = current[fil][col] / 2;
		else
		{
			FireBox.b = current[fil][col];
			FireBox.g = current[fil][col] / 3;
		}
		GsSortBoxFill( &FireBox, &WorldOT[activeBuff], 1 );
	}
}


